// Change this to set the name of the managed resource store to create.
// You use the name with the createManagedStore, and removeManagedStore,
// and openManagedStore APIs. It isn't visible to the user.
var STORE_NAME = "SilverlightGearedUp";

// Change this to set the URL of tha manifest file, which describe which
// URLs to capture. It can be relative to the current page, or an
// absolute URL.
var MANIFEST_FILENAME = "manifest.json";

var localServer;
var store;

// Called onload to initialize local server and store variables
function init() {
  if (!window.google || !google.gears) {
    textOut("NOTE:  You must install Google Gears first.");
  } 
  else 
  {
    try
    {
        localServer = google.gears.factory.create("beta.localserver","1.0");  //throws exception is user denys
        store = localServer.createManagedStore(STORE_NAME);
        textOut("Yeay, Google Gears is already installed.");
    }
    catch (e)
    {
        textOut("Denied!");
    }
  }
}

// Create the managed resource store   Check store != null.  Undeefined is denyed
function createStore() {
  if (!window.google || !google.gears) {
    alert("You have not got Google Gears installed.");
    return;
  }

    if(store != undefined)
    {
        store.manifestUrl = MANIFEST_FILENAME;
        store.checkForUpdate();

        var timerId = window.setInterval(function() {
            // When the currentVersion property has a value, all of the resources
            // listed in the manifest file for that version are captured. There is
            // an open bug to surface this state change as an event.
            if (store.currentVersion) {
              window.clearInterval(timerId);
              textOut("The documents are now available offline.\n" + 
                      "With your browser offline, load the document at " +
                      "its normal online URL to see the locally stored " +
	                        "version. The version stored is: " + 
                      store.currentVersion);
            } 
            else if (store.updateStatus == 3) 
            {
              textOut("Error: " + store.lastErrorMessage);
            }
        }, 500);  
    }
    else
    {
        textOut("Store is undefined");
    }
}

// Remove the managed resource store.
function removeStore() {
    if (!window.google || !google.gears) {
        alert("You must install Google Gears first.");
        return;
    }

    localServer.removeManagedStore(STORE_NAME);
    textOut("Done. The local store has been removed." +
          "You will now see online versions of the documents.");
}

// Utility function to output some status text.  Crashes on first hit - cant find DIV.
function textOut(s) {
    try
    {
        var elm = document.getElementById("textOut");
        while (elm.firstChild) 
        {
            elm.removeChild(elm.firstChild);
        } 
        elm.appendChild(document.createTextNode(s));
    }
    catch (e) {}
}
